# cnaclib : Librairie Python developpee pour les usagers et les employes de la CNAC. 

## About cnaclib

**cnaclib** est un package `Python` dedie aux usagers et aux employes de la CNAC.

## Pourquoi utiliser cnaclib?

* Il dispose de plusieurs modules et fonctions `Python` pour : 
    * Faire une simulation de calculs pour le benefice du regime assurance chomage (RAC);
    * Faire une simulation de calculs pour le benefice des mesures encouragement a emploi (loi 06-21);
    * Generer la liste des codes de wilaya de 01 a 58;
    * Avoir le nom de la wilaya en arabe ou en francais en fonction de son code ;
    * Avoir le code de la wilaya en fonction de son nom en arabe ou en francais;
    * Generer des dossiers qui postent le nom des wilayas en arabe ou en francais;
    * Avoir le montant du SNMG en fonction de la date a compter du 01/01/1990;

* Il sera mis a jour regulierement par des modules qui peuvent automatiser certaines taches.


## Installation

### Dependencies

cnaclib requires 

```
certifi >=2023.5.7
charset-normalizer >=3.1.0
idna >=3.4
numpy >=1.24.3
pandas >=2.0.1
python-dateutil >=2.8.2
pytz >=2023.3
six >=1.16.0
tzdata >=2023.3
urllib3 >=2.0.2
```

### User installation

You can install cnaclib using `pip` :

```
pip install cnaclib
```

Tutorial are available

````
https://github.com/aistatendz/cnaclib/blob/master/Exemple_RAC_01.ipynb
https://github.com/aistatendz/cnaclib/blob/master/Exemple_RAC_02.ipynb
https://github.com/aistatendz/cnaclib/blob/master/Exemple_LSix21_01.ipynb
https://github.com/aistatendz/cnaclib/blob/master/Exemple_LSix21_02.ipynb
https://github.com/aistatendz/cnaclib/blob/master/Exemple_Tools_01.ipynb
https://github.com/aistatendz/cnaclib/blob/master/Exemple_Tools_02.ipynb
https://github.com/aistatendz/cnaclib/blob/master/Exemple_Tools_03.ipynb
````

## Author

BENHAMADA Nadir ([aistatendz@gmail.com](aistatendz@gmail.com))
